> ## Documentation Index
> Fetch the complete documentation index at: https://docs.controlplane.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Perform a Patch on a volumeset by name



## OpenAPI

````yaml patch /org/{org}/gvc/{gvc}/volumeset/{name}
openapi: 3.0.3
info:
  title: Control Plane Core API
  description: Copyright © 2023 Control Plane Corporation. All rights reserved.
  version: 1.0.0
servers:
  - url: https://api.cpln.io
    description: ''
security:
  - {}
  - serviceAccountKey: []
  - jwt: []
externalDocs:
  url: https://docs.controlplane.com/
  description: End-user documentation
paths:
  /org/{org}/gvc/{gvc}/volumeset/{name}:
    patch:
      tags:
        - volumeset
      summary: Perform a Patch on a volumeset by name
      parameters:
        - in: path
          name: org
          required: true
          schema:
            type: string
        - in: path
          name: gvc
          required: true
          schema:
            type: string
        - in: path
          name: name
          required: true
          schema:
            type: string
      requestBody:
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/patch_volumeset'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/volumeset'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error'
        '403':
          description: Access denied
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error'
components:
  schemas:
    patch_volumeset:
      type: object
      properties:
        $drop:
          type: array
          items:
            type: string
            enum:
              - description
              - tags
              - spec
              - gvc
        name:
          type: string
          maxLength: 64
        description:
          type: string
          maxLength: 250
        tags:
          type: object
          properties: {}
        $replace/tags:
          type: object
        spec:
          $ref: '#/components/schemas/patch_volumeset_spec'
        $replace/spec:
          $ref: '#/components/schemas/volumeset_spec'
        gvc:
          type: object
          properties: {}
        $replace/gvc:
          type: object
    volumeset:
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
          maxLength: 64
        kind:
          type: string
          readOnly: true
        version:
          type: integer
          readOnly: true
        description:
          type: string
          maxLength: 250
        tags:
          type: object
        created:
          type: string
          format: date-time
          readOnly: true
        lastModified:
          type: string
          format: date-time
          readOnly: true
        links:
          type: array
          items:
            $ref: '#/components/schemas/link'
          readOnly: true
        spec:
          $ref: '#/components/schemas/volumeset_spec'
        status:
          $ref: '#/components/schemas/volumeset_status'
          readOnly: true
        gvc:
          type: object
      additionalProperties: false
    error:
      type: object
      properties:
        status:
          type: integer
        message:
          type: string
        code:
          type: string
        details:
          type: object
        id:
          type: string
      additionalProperties: false
    patch_volumeset_spec:
      type: object
      properties:
        $drop:
          type: array
          items:
            type: string
            enum:
              - initialCapacity
              - performanceClass
              - storageClassSuffix
              - fileSystemType
              - customEncryption
              - snapshots
              - autoscaling
              - mountOptions
        initialCapacity:
          type: integer
          description: The initial size in GB of volumes in this set.
        performanceClass:
          type: string
          enum:
            - general-purpose-ssd
            - high-throughput-ssd
            - shared
        storageClassSuffix:
          type: string
          description: >-
            For self-hosted locations only. The storage class used for volumes
            in this set will be
            {performanceClass}-{fileSystemType}-{storageClassSuffix} if it
            exists, otherwise it will be {performanceClass}-{fileSystemType}
        fileSystemType:
          type: string
          enum:
            - ext4
            - xfs
            - shared
          default: ext4
        customEncryption:
          type: object
          properties:
            $drop:
              type: array
              items:
                type: string
                enum:
                  - regions
            regions:
              type: object
              properties: {}
            $replace/regions:
              type: object
        $replace/customEncryption:
          type: object
          properties:
            regions:
              type: object
          additionalProperties: false
          description: >-
            Configure customer-managed encryption keys for volumes in this set
            on a per-region basis. Region names must follow the format:
            {cloud-provider}-{region} (e.g., aws-us-east-1).
        snapshots:
          type: object
          properties:
            $drop:
              type: array
              items:
                type: string
                enum:
                  - createFinalSnapshot
                  - retentionDuration
                  - schedule
            createFinalSnapshot:
              type: boolean
              description: >-
                If true, a volume snapshot will be created immediately before
                deletion of any volume in this set
            retentionDuration:
              type: string
              description: >-
                The default retention period for volume snapshots. This string
                should contain a floating point number followed by either d, h,
                or m. For example, "10d" would retain snapshots for 10 days.
            schedule:
              type: string
              description: >-
                A standard cron schedule expression used to determine when your
                job should execute.
        $replace/snapshots:
          type: object
          properties:
            createFinalSnapshot:
              type: boolean
              description: >-
                If true, a volume snapshot will be created immediately before
                deletion of any volume in this set
            retentionDuration:
              type: string
              description: >-
                The default retention period for volume snapshots. This string
                should contain a floating point number followed by either d, h,
                or m. For example, "10d" would retain snapshots for 10 days.
            schedule:
              type: string
              description: >-
                A standard cron schedule expression used to determine when your
                job should execute.
          additionalProperties: false
        autoscaling:
          type: object
          properties:
            $drop:
              type: array
              items:
                type: string
                enum:
                  - maxCapacity
                  - minFreePercentage
                  - scalingFactor
                  - predictive
            maxCapacity:
              type: integer
              description: >-
                The maximum size in GB for a volume in this set. A volume cannot
                grow to be bigger than this.
            minFreePercentage:
              type: number
              description: >-
                The guaranteed free space on the volume as a percentage of the
                volume's total size. ControlPlane will try to maintain at least
                that many percent free by scaling up the total size
            scalingFactor:
              type: number
              description: >-
                When scaling is necessary, then new_capacity = current_capacity
                * storageScalingFactor.
            predictive:
              type: object
              properties:
                $drop:
                  type: array
                  items:
                    type: string
                    enum:
                      - enabled
                      - lookbackHours
                      - projectionHours
                      - minDataPoints
                      - minGrowthRateGBPerHour
                      - scalingFactor
                enabled:
                  type: boolean
                  description: >-
                    Enable predictive scaling based on historical growth rates.
                    Default: false.
                lookbackHours:
                  type: number
                  description: >-
                    Hours of historical data to analyze. Default: 24. Max: 168
                    (1 week).
                projectionHours:
                  type: number
                  description: 'Hours into the future to project storage needs. Default: 6.'
                minDataPoints:
                  type: integer
                  description: >-
                    Minimum data points required for reliable growth rate
                    calculation. Default: 10.
                minGrowthRateGBPerHour:
                  type: number
                  description: >-
                    Minimum growth rate (GB/hour) to trigger predictive
                    expansion. Default: 0.01.
                scalingFactor:
                  type: number
                  description: >-
                    Scaling factor for predictive expansion. If not set, uses
                    the parent autoscaling.scalingFactor. Use a lower value
                    (e.g., 1.2) for gentler proactive scaling.
            $replace/predictive:
              type: object
              properties:
                enabled:
                  type: boolean
                  description: >-
                    Enable predictive scaling based on historical growth rates.
                    Default: false.
                lookbackHours:
                  type: number
                  description: >-
                    Hours of historical data to analyze. Default: 24. Max: 168
                    (1 week).
                projectionHours:
                  type: number
                  description: 'Hours into the future to project storage needs. Default: 6.'
                minDataPoints:
                  type: integer
                  description: >-
                    Minimum data points required for reliable growth rate
                    calculation. Default: 10.
                minGrowthRateGBPerHour:
                  type: number
                  description: >-
                    Minimum growth rate (GB/hour) to trigger predictive
                    expansion. Default: 0.01.
                scalingFactor:
                  type: number
                  description: >-
                    Scaling factor for predictive expansion. If not set, uses
                    the parent autoscaling.scalingFactor. Use a lower value
                    (e.g., 1.2) for gentler proactive scaling.
              additionalProperties: false
              description: >-
                Predictive scaling configuration. When enabled, proactively
                expands volumes based on historical growth rate projections.
        $replace/autoscaling:
          type: object
          properties:
            maxCapacity:
              type: integer
              description: >-
                The maximum size in GB for a volume in this set. A volume cannot
                grow to be bigger than this.
            minFreePercentage:
              type: number
              description: >-
                The guaranteed free space on the volume as a percentage of the
                volume's total size. ControlPlane will try to maintain at least
                that many percent free by scaling up the total size
            scalingFactor:
              type: number
              description: >-
                When scaling is necessary, then new_capacity = current_capacity
                * storageScalingFactor.
            predictive:
              type: object
              properties:
                enabled:
                  type: boolean
                  description: >-
                    Enable predictive scaling based on historical growth rates.
                    Default: false.
                lookbackHours:
                  type: number
                  description: >-
                    Hours of historical data to analyze. Default: 24. Max: 168
                    (1 week).
                projectionHours:
                  type: number
                  description: 'Hours into the future to project storage needs. Default: 6.'
                minDataPoints:
                  type: integer
                  description: >-
                    Minimum data points required for reliable growth rate
                    calculation. Default: 10.
                minGrowthRateGBPerHour:
                  type: number
                  description: >-
                    Minimum growth rate (GB/hour) to trigger predictive
                    expansion. Default: 0.01.
                scalingFactor:
                  type: number
                  description: >-
                    Scaling factor for predictive expansion. If not set, uses
                    the parent autoscaling.scalingFactor. Use a lower value
                    (e.g., 1.2) for gentler proactive scaling.
              additionalProperties: false
              description: >-
                Predictive scaling configuration. When enabled, proactively
                expands volumes based on historical growth rate projections.
          additionalProperties: false
        mountOptions:
          type: object
          properties:
            $drop:
              type: array
              items:
                type: string
                enum:
                  - resources
            resources:
              type: object
              properties:
                $drop:
                  type: array
                  items:
                    type: string
                    enum:
                      - maxCpu
                      - minCpu
                      - minMemory
                      - maxMemory
                maxCpu:
                  type: string
                  maxLength: 20
                  default: 2000m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minCpu:
                  type: string
                  maxLength: 20
                  default: 500m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minMemory:
                  type: string
                  maxLength: 20
                  default: 1Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
                maxMemory:
                  type: string
                  maxLength: 20
                  default: 2Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
            $replace/resources:
              type: object
              properties:
                maxCpu:
                  type: string
                  maxLength: 20
                  default: 2000m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minCpu:
                  type: string
                  maxLength: 20
                  default: 500m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minMemory:
                  type: string
                  maxLength: 20
                  default: 1Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
                maxMemory:
                  type: string
                  maxLength: 20
                  default: 2Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
              additionalProperties: false
              description: >-
                For volume sets using the shared file system, this object
                specifies the CPU and memory resources allotted to each mount
                point
        $replace/mountOptions:
          type: object
          properties:
            resources:
              type: object
              properties:
                maxCpu:
                  type: string
                  maxLength: 20
                  default: 2000m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minCpu:
                  type: string
                  maxLength: 20
                  default: 500m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minMemory:
                  type: string
                  maxLength: 20
                  default: 1Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
                maxMemory:
                  type: string
                  maxLength: 20
                  default: 2Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
              additionalProperties: false
              description: >-
                For volume sets using the shared file system, this object
                specifies the CPU and memory resources allotted to each mount
                point
          additionalProperties: false
          description: A list of mount options to use when mounting volumes in this set.
    volumeset_spec:
      type: object
      properties:
        initialCapacity:
          type: integer
          description: The initial size in GB of volumes in this set.
        performanceClass:
          type: string
          enum:
            - general-purpose-ssd
            - high-throughput-ssd
            - shared
        storageClassSuffix:
          type: string
          description: >-
            For self-hosted locations only. The storage class used for volumes
            in this set will be
            {performanceClass}-{fileSystemType}-{storageClassSuffix} if it
            exists, otherwise it will be {performanceClass}-{fileSystemType}
        fileSystemType:
          type: string
          enum:
            - ext4
            - xfs
            - shared
          default: ext4
        customEncryption:
          type: object
          properties:
            regions:
              type: object
          additionalProperties: false
          description: >-
            Configure customer-managed encryption keys for volumes in this set
            on a per-region basis. Region names must follow the format:
            {cloud-provider}-{region} (e.g., aws-us-east-1).
        snapshots:
          type: object
          properties:
            createFinalSnapshot:
              type: boolean
              description: >-
                If true, a volume snapshot will be created immediately before
                deletion of any volume in this set
            retentionDuration:
              type: string
              description: >-
                The default retention period for volume snapshots. This string
                should contain a floating point number followed by either d, h,
                or m. For example, "10d" would retain snapshots for 10 days.
            schedule:
              type: string
              description: >-
                A standard cron schedule expression used to determine when your
                job should execute.
          additionalProperties: false
        autoscaling:
          type: object
          properties:
            maxCapacity:
              type: integer
              description: >-
                The maximum size in GB for a volume in this set. A volume cannot
                grow to be bigger than this.
            minFreePercentage:
              type: number
              description: >-
                The guaranteed free space on the volume as a percentage of the
                volume's total size. ControlPlane will try to maintain at least
                that many percent free by scaling up the total size
            scalingFactor:
              type: number
              description: >-
                When scaling is necessary, then new_capacity = current_capacity
                * storageScalingFactor.
            predictive:
              type: object
              properties:
                enabled:
                  type: boolean
                  description: >-
                    Enable predictive scaling based on historical growth rates.
                    Default: false.
                lookbackHours:
                  type: number
                  description: >-
                    Hours of historical data to analyze. Default: 24. Max: 168
                    (1 week).
                projectionHours:
                  type: number
                  description: 'Hours into the future to project storage needs. Default: 6.'
                minDataPoints:
                  type: integer
                  description: >-
                    Minimum data points required for reliable growth rate
                    calculation. Default: 10.
                minGrowthRateGBPerHour:
                  type: number
                  description: >-
                    Minimum growth rate (GB/hour) to trigger predictive
                    expansion. Default: 0.01.
                scalingFactor:
                  type: number
                  description: >-
                    Scaling factor for predictive expansion. If not set, uses
                    the parent autoscaling.scalingFactor. Use a lower value
                    (e.g., 1.2) for gentler proactive scaling.
              additionalProperties: false
              description: >-
                Predictive scaling configuration. When enabled, proactively
                expands volumes based on historical growth rate projections.
          additionalProperties: false
        mountOptions:
          type: object
          properties:
            resources:
              type: object
              properties:
                maxCpu:
                  type: string
                  maxLength: 20
                  default: 2000m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minCpu:
                  type: string
                  maxLength: 20
                  default: 500m
                  description: CPU allocation specified as millicores (e.g., 50m, 1000m)
                minMemory:
                  type: string
                  maxLength: 20
                  default: 1Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
                maxMemory:
                  type: string
                  maxLength: 20
                  default: 2Gi
                  description: >-
                    Memory allocation specified as a string with units (e.g.,
                    128Mi, 1Gi, 512M). Supports G, M, k, Gi, Mi, Ki suffixes.
              additionalProperties: false
              description: >-
                For volume sets using the shared file system, this object
                specifies the CPU and memory resources allotted to each mount
                point
          additionalProperties: false
          description: A list of mount options to use when mounting volumes in this set.
      additionalProperties: false
    link:
      type: object
      properties:
        rel:
          type: string
        href:
          type: string
      additionalProperties: false
    volumeset_status:
      type: object
      properties:
        parentId:
          type: string
        usedByWorkload:
          type: string
        workloadLinks:
          type: array
          items:
            type: string
        bindingId:
          type: string
        locations:
          type: array
          items:
            type: object
            properties:
              name:
                type: string
                description: The name of the location in which this volume was provisioned
              volumes:
                type: array
                items:
                  type: object
                  properties:
                    lifecycle:
                      type: string
                      enum:
                        - creating
                        - unused
                        - unbound
                        - bound
                        - deleted
                        - repairing
                      default: creating
                    storageDeviceId:
                      type: string
                      description: >-
                        The id of the volume as provided by the underlying
                        storage implementation. If this is blank, an actual
                        storage device has not yet been created.
                    oldStorageDeviceIds:
                      type: array
                      items:
                        type: string
                      description: >-
                        The most recently used storageDeviceId. This is meant
                        for use by Control Plane only
                    resourceName:
                      type: string
                    index:
                      type: integer
                      description: >-
                        This number is used to order volumes within the volume
                        set. It is used by Control Plane to link volumes with
                        the workload replicas that use them.
                    currentSize:
                      type: number
                      description: The current capacity of the volume in GB
                    currentBytesUsed:
                      type: number
                      description: The total bytes used in the volume.
                    currentBytesFree:
                      type: number
                      description: >-
                        The total free bytes available in the volume. Persisted
                        from the latest filesystem stats so the value survives
                        while the volume is unmounted.
                    iops:
                      type: number
                    throughput:
                      type: number
                    driver:
                      type: string
                      description: >-
                        The name of the CSI driver used to provision and manage
                        this volume
                    volumeSnapshots:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            description: A human-readable name for this snapshot.
                          id:
                            type: string
                            description: >-
                              The id of the snapshot as provided by the
                              underlying storage implementation.
                          created:
                            type: string
                            format: date-time
                            description: >-
                              The date and time that the snapshot was created in
                              the Control Plane API
                          expires:
                            type: string
                            format: date-time
                            description: >-
                              The date and time on which this snapshot will be
                              automatically deleted.
                          size:
                            type: number
                            description: The size of the snapshot in GB.
                          tags:
                            type: array
                            items:
                              type: object
                        additionalProperties: false
                    attributes:
                      type: object
                    zone:
                      type: string
                  additionalProperties: false
              desiredVolumeCount:
                type: integer
              clusterId:
                type: string
                description: The id of the cluster assigned to the gvc in this location.
            additionalProperties: false
      additionalProperties: false
  securitySchemes:
    serviceAccountKey:
      type: apiKey
      in: header
      name: Authorization
      description: Service account key can be used as API keys
    jwt:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: IDP-provided token

````